﻿Imports System.Data
Imports System.Web.Services
Imports System.Web.Script.Services

Partial Class Default2
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    <WebMethod()> _
       <ScriptMethod(ResponseFormat:=ResponseFormat.Json)> _
    Public Shared Function Cargar1(skip As Integer, take As Integer, codigo As String) As Object
        Dim implementacion As New implementacion
        Try
            Dim listaDetalles = implementacion.listar(codigo)
            Dim entidad As New entidadresult()
            entidad.result = listaDetalles.Skip(skip).Take(take).ToList()
            entidad.count = listaDetalles.Count()
            Return entidad

        Catch ex As Exception
            Throw ex
        End Try
    End Function

    <WebMethod()> _
       <ScriptMethod(ResponseFormat:=ResponseFormat.Json)> _
    Public Shared Function Cargar2(skip As Integer, take As Integer, codigo As String) As Object
        Dim implementacion As New implementacion
        Try
            Dim listaDetalles = implementacion.listar(codigo)
            Dim entidad As New entidadresult()
            entidad.result = listaDetalles.Skip(skip).Take(take).ToList()
            entidad.count = listaDetalles.Count()
            Return entidad

        Catch ex As Exception
            Throw ex
        End Try
    End Function

    <WebMethod()> _
       <ScriptMethod(ResponseFormat:=ResponseFormat.Json)> _
    Public Shared Function Cargar3(skip As Integer, take As Integer, codigo As String) As Object
        Dim implementacion As New implementacion
        Try
            Dim listaDetalles = implementacion.listar(codigo)
            Dim entidad As New entidadresult()
            entidad.result = listaDetalles.Skip(skip).Take(take).ToList()
            entidad.count = listaDetalles.Count()
            Return entidad

        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Protected Sub ibtnNuevo_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ibtnNuevo.Click
        EnableNuevo(False)
        EnableCancelar(True)
        hdfCodigo.Value = 2
    End Sub

    Protected Sub ibtnCancelar_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ibtnCancelar.Click
        EnableNuevo(True)
        EnableCancelar(False)
        hdfCodigo.Value = 1
    End Sub

    Sub EnableNuevo(ByVal value As Boolean)
        If value = False Then
            ibtnNuevo.Enabled = False
            ibtnNuevo.ImageUrl = "~/images/NewButtonbn.jpg"
        Else
            ibtnNuevo.Enabled = True
            ibtnNuevo.ImageUrl = "~/images/NewButton.jpg"
        End If
    End Sub

    Sub EnableCancelar(ByVal value As Boolean)
        If value = False Then
            ibtnCancelar.Enabled = False
            ibtnCancelar.ImageUrl = "~/images/cancelbn.jpg"
        Else
            ibtnCancelar.Enabled = True
            ibtnCancelar.ImageUrl = "~/images/cancel.jpg"
        End If
    End Sub

    Public Class implementacion

        Public Function listar(ByVal codigo As String) As List(Of entidad)
            Dim lista As New List(Of entidad)
            If codigo = 1 Then
                Try
                    Dim tabla As New DataTable
                    tabla.Columns.Add("Codigo")
                    tabla.Columns.Add("Nombre")
                    tabla.AcceptChanges()
                    For index = 1 To 100
                        Dim fila = tabla.NewRow
                        fila("Codigo") = index
                        fila("Nombre") = "Actividad " + index.ToString
                        tabla.Rows.Add(fila)
                    Next
                    tabla.AcceptChanges()

                    For Each fila As DataRow In tabla.Rows
                        Dim entidad As New entidad
                        entidad.Codigo = fila("Codigo")
                        entidad.Nombre = fila("Nombre")
                        lista.Add(entidad)
                    Next
                Catch ex As Exception
                    Throw ex
                End Try
            End If
            Return lista
        End Function

    End Class

    <Serializable> _
    Public Class entidad

        Public Sub New()
        End Sub

        Public Sub New(Codigo As Integer, Nombre As String)
            Me.Codigo = Codigo
            Me.Nombre = Nombre
        End Sub

        Public Property Codigo() As Integer
            Get
                Return m_codigo
            End Get
            Set(value As Integer)
                m_codigo = value
            End Set
        End Property
        Private m_codigo As Integer

        Public Property Nombre() As String
            Get
                Return m_nombre
            End Get
            Set(value As String)
                m_nombre = value
            End Set
        End Property
        Private m_nombre As String

    End Class

    Public Class entidadresult
        Public Property result() As IEnumerable(Of entidad)
            Get
                Return m_result
            End Get
            Set(value As IEnumerable(Of entidad))
                m_result = value
            End Set
        End Property
        Private m_result As IEnumerable(Of entidad)
        Public Property count() As Integer
            Get
                Return m_count
            End Get
            Set(value As Integer)
                m_count = value
            End Set
        End Property
        Private m_count As Integer
    End Class


End Class
